"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = filter;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _numericExpressionHelper = _interopRequireDefault(require("../helpers/numericExpressionHelper"));

var _stringExpressionHelper = _interopRequireDefault(require("../helpers/stringExpressionHelper"));

var _booleanLogicHelper = _interopRequireDefault(require("../helpers/booleanLogicHelper"));

var _isExpressionHelper = _interopRequireDefault(require("../helpers/isExpressionHelper"));

var _arrayEqualityHelper = _interopRequireDefault(require("../helpers/arrayEqualityHelper"));

var _arrayExpressionHelper = _interopRequireDefault(require("../helpers/arrayExpressionHelper"));

var _getKeyHelper = _interopRequireDefault(require("../helpers/getKeyHelper"));

var objectExpressionHandlers = {
  "number": _numericExpressionHelper["default"],
  "string": _stringExpressionHelper["default"],
  "object": function object(expression, value) {
    if (Array.isArray(expression.value)) {
      return (0, _arrayExpressionHelper["default"])(expression, value);
    }

    console.warn("Reached path that should be unreachable! Expression was:");
    console.warn(expression);
  }
};

function filter(query, data) {
  var filtered = data.filter(function (entry) {
    return match(query, entry);
  });
  return filtered;
}

;

function isBooleanLogic(obj) {
  return obj.hasOwnProperty("expression") || obj.hasOwnProperty("expressions");
}

function match(query, entry) {
  var acc = true;

  if (isBooleanLogic(query)) {
    return (0, _booleanLogicHelper["default"])(null, query, entry, match);
  }

  for (var _i = 0, _Object$entries = Object.entries(query); _i < _Object$entries.length; _i++) {
    var _Object$entries$_i = (0, _slicedToArray2["default"])(_Object$entries[_i], 2),
        key = _Object$entries$_i[0],
        value = _Object$entries$_i[1];

    key = (0, _getKeyHelper["default"])(key);

    if (isBooleanLogic(value)) {
      acc = acc && (0, _booleanLogicHelper["default"])(key, value, entry, match);
    } else {
      switch ((0, _typeof2["default"])(value)) {
        case "object":
          if ((0, _isExpressionHelper["default"])(value)) {
            var expType = (0, _typeof2["default"])(value.value);
            acc = acc && objectExpressionHandlers[expType](value, entry[key]);
          } else if (Array.isArray(value)) {
            acc = acc && (0, _arrayEqualityHelper["default"])(value, entry[key]);
          } else {
            return match(value, entry[key]);
          }

          break;

        case "string":
        case "number":
          acc = acc && entry[key] == value;
          break;
      }
    }
  }

  return acc;
}