"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = arrayExpressionHelper;

var _arrayEqualityHelper = _interopRequireDefault(require("./arrayEqualityHelper"));

var handlers = {
  contains: function contains(haystack, needles) {
    var acc = true;
    needles.forEach(function (needle) {
      acc = acc && haystack.includes(needle);
    });
    return acc;
  },
  containsAny: function containsAny(haystack, needles) {
    var acc = false;
    needles.forEach(function (needle) {
      acc = acc || haystack.includes(needle);
    });
    return acc;
  },
  "=": function _(left, right) {
    return (0, _arrayEqualityHelper["default"])(left, right);
  }
};

function arrayExpressionHelper(expression, value) {
  return handlers[expression.op](value, expression.value);
}

;