"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = booleanLogicHelper;
var handlers = {
  "not": function not(key, expression, value, match) {
    var query = getQuery(key, expression.expression);
    return !match(query, value);
  },
  "or": function or(key, expression, value, match) {
    var matched = false;
    expression.expressions.forEach(function (expr) {
      var query = getQuery(key, expr);
      matched = matched || match(query, value);
    });
    return matched;
  },
  "and": function and(key, expression, value, match) {
    var matched = true;
    expression.expressions.forEach(function (expr) {
      var query = getQuery(key, expr);
      matched = matched && match(query, value);
    });
    return matched;
  }
};

function getQuery(key, expr) {
  var query = {};

  if (key) {
    query[key] = expr;
  } else {
    query = expr;
  }

  return query;
}

function booleanLogicHelper(key, expression, value, match) {
  return handlers[expression.op](key, expression, value, match);
}